(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     33053,       1040]
NotebookOptionsPosition[     31417,        980]
NotebookOutlinePosition[     31760,        995]
CellTagsIndexPosition[     31717,        992]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["LegendreP[ ] with and without evaluation", "Title",
 CellChangeTimes->{{3.5084810253030653`*^9, 3.5084810718493447`*^9}}],

Cell["\<\
Copyright \[Copyright] MathCore AB 1998-2011\
\>", "Copyright",
 CellChangeTimes->{{3.508481056130796*^9, 3.508481057474529*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<MathCode`\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.4894825892394085`*^9, 3.4894825892394085`*^9}, {
  3.489482620910676*^9, 3.4894826580193386`*^9}, {3.489482801266588*^9, 
  3.4894828037196655`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"MathCode C++ 1.4.4\"\>", "\[InvisibleSpace]", "\<\" for \"\>", 
   "\[InvisibleSpace]", "\<\"vc90\"\>", 
   "\[InvisibleSpace]", "\<\" loaded from \"\>", 
   "\[InvisibleSpace]", "\<\"C:\\\\b\\\\omath\\\\MathCode\"\>"}],
  SequenceForm[
  "MathCode C++ 1.4.4", " for ", "vc90", " loaded from ", 
   "C:\\b\\omath\\MathCode"],
  Editable->False]], "Print",
 CellChangeTimes->{3.4894864606963253`*^9, 3.4894872057288957`*^9, 
  3.489489127020131*^9, 3.4894893277037783`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"$MCRoot", "<>", "\"\</Demos/EvaluateFunctions\>\""}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.4894825892394085`*^9, 3.4894825892394085`*^9}, {
  3.489482620910676*^9, 3.4894826580193386`*^9}, {3.489482801266588*^9, 
  3.489482806375865*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetCompilationOptions", "[", 
    RowBox[{"EvaluateFunctions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"LegendreReal2Real", ",", "LegendreComplex2Complex"}], "}"}]}], 
    "]"}], ";"}]}]], "Input",
 CellChangeTimes->{{3.4894825892394085`*^9, 3.4894825892394085`*^9}, {
  3.489482620910676*^9, 3.4894826580193386`*^9}, {3.489482801266588*^9, 
  3.489482809078938*^9}, {3.4894830859017477`*^9, 3.4894830944328337`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LegendreReal2Real", "[", 
     RowBox[{"Real", " ", "xh_"}], "]"}], "\[Rule]", 
    RowBox[{"Real", "[", "_", "]"}]}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"LegendreP", "[", 
       RowBox[{"nh", ",", "xh"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"nh", ",", "0", ",", "15"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4894825892394085`*^9, 3.4894825892394085`*^9}, {
  3.489482620910676*^9, 3.4894826580193386`*^9}, {3.489482801266588*^9, 
  3.489482813922595*^9}, {3.4894830598397484`*^9, 3.489483064995899*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LegendreComplex2Complex", "[", 
      RowBox[{"Complex", " ", "xh_"}], "]"}], "\[Rule]", 
     RowBox[{"Complex", "[", "_", "]"}]}], "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{"LegendreP", "[", 
        RowBox[{"nh", ",", "xh"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"nh", ",", "0", ",", "15"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.4894825892394085`*^9, 3.4894825892394085`*^9}, {
  3.489482620910676*^9, 3.4894826580193386`*^9}, {3.489482801266588*^9, 
  3.489482811157023*^9}, {3.4894829162800045`*^9, 3.489482918779957*^9}, {
  3.4894830693551903`*^9, 3.489483080417478*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LegendreReal2RealNoEvaluate", "[", 
      RowBox[{"Complex", " ", "xh_"}], "]"}], "\[Rule]", 
     RowBox[{"Complex", "[", "_", "]"}]}], "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", 
       RowBox[{"LegendreP", "[", 
        RowBox[{"nh", ",", "xh"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"nh", ",", "0", ",", "15"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.4894825892394085`*^9, 3.4894825892394085`*^9}, {
  3.489482620910676*^9, 3.4894826580193386`*^9}, {3.489482801266588*^9, 
  3.489482813922595*^9}, {3.4894830598397484`*^9, 3.489483064995899*^9}, {
  3.4894832004307985`*^9, 3.489483209446251*^9}, {3.489485946940565*^9, 
  3.489485999361433*^9}, {3.4894863212615027`*^9, 3.489486433212478*^9}, {
  3.489486480008455*^9, 3.489486492695711*^9}, {3.4894869594055*^9, 
  3.4894869619523263`*^9}, {3.489487042263284*^9, 3.489487143230096*^9}, {
  3.489487332163968*^9, 3.489487349335513*^9}, {3.489489180300358*^9, 
  3.489489187690841*^9}, {3.4894892378617525`*^9, 3.4894892390179806`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BuildCode", "[", "]"}]], "Input",
 CellChangeTimes->{
  3.489482668987878*^9, {3.489482831422259*^9, 3.48948283551593*^9}}],

Cell[BoxData["\<\"Successful compilation to C++: 3 function(s)\"\>"], "Print",
 CellChangeTimes->{3.489489130066948*^9, 3.489489330375602*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"MakeBinary", "[", "]"}]], "Input",
 CellChangeTimes->{{3.489487447880496*^9, 3.4894874524585333`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FilePrint", "[", "\"\<Global.cc\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.4894829246235943`*^9, 3.4894829526855555`*^9}, 
   3.4894893013292847`*^9}],

Cell["\<\
#include \"Global.h\"

#include \"Global.icc\"

#include <math.h>
void Global_TGlobalInit ()
{
; 
}

lm_complexN Global_TLegendreReal2RealNoEvaluate ( const lm_complex &xh)
{
    return 
        light_flatten(make_lightN(2,
            make_lightN(10,1,xh,(-1+3*(xh*xh))/2,(-3*xh+5*(xh*xh*xh))/2,(3+-\
30*(
        xh*xh)+35*(xh*xh*xh*xh))/8,(15*xh+-70*(xh*xh*xh)+63*pow(xh, 5))/8,(-5+
        105*(xh*xh)+-315*(xh*xh*xh*xh)+231*pow(xh, \
6))/16,(-35*xh+315*(xh*xh*xh)
        +-693*pow(xh, 5)+429*pow(xh, \
7))/16,(35+-1260*(xh*xh)+6930*(xh*xh*xh*xh)
        +-12012*pow(xh, 6)+6435*pow(xh, 8))/128,(315*xh+-4620*(xh*xh*xh)+18018*
        pow(xh, 5)+-25740*pow(xh, 7)+12155*pow(xh, 9))/128),
            make_lightN(6,(-63+3465*(xh*xh)+-30030*(xh*xh*xh*xh)+90090*pow(xh,\
 6
        )+-109395*pow(xh, 8)+46189*pow(xh, 10))/256,(-693*xh+15015*(xh*xh*xh)+-
        90090*pow(xh, 5)+218790*pow(xh, 7)+-230945*pow(xh, 9)+88179*pow(xh, \
11))
        /256,(231+-18018*(xh*xh)+225225*(xh*xh*xh*xh)+-1021020*pow(xh, 6)+
        2078505*pow(xh, 8)+-1939938*pow(xh, 10)+676039*pow(xh, 12))/1024,(3003*
        xh+-90090*(xh*xh*xh)+765765*pow(xh, 5)+-2771340*pow(xh, 7)+4849845*pow(
        xh, 9)+-4056234*pow(xh, 11)+1300075*pow(xh, \
13))/1024,(-429+45045*(xh*xh
        )+-765765*(xh*xh*xh*xh)+4849845*pow(xh, 6)+-14549535*pow(xh, \
8)+22309287
        *pow(xh, 10)+-16900975*pow(xh, 12)+5014575*pow(xh, 14))/2048,(-6435*xh+
        255255*(xh*xh*xh)+-2909907*pow(xh, 5)+14549535*pow(xh, \
7)+-37182145*pow(
        xh, 9)+50702925*pow(xh, 11)+-35102025*pow(xh, 13)+9694845*pow(xh, 15))/
        2048) ))(R(1,16));
}

lm_complexN Global_TLegendreComplex2Complex ( const lm_complex &xh)
{
    lm_complex mc_T1;
    lm_complex mc_T2;
    lm_complex mc_T3;
    lm_complex mc_T4;
    lm_complex mc_T5;
    lm_complex mc_T6;
    lm_complex mc_T7;
    lm_complex mc_T8;
    lm_complex mc_T9;
    lm_complex mc_T10;
    lm_complex mc_T11;
    lm_complex mc_T12;
    lm_complex mc_T13;
    lm_complex mc_T14;
    lm_complex mc_T15;
    lm_complex mc_T16;
    lm_complex mc_T17;
    lm_complex mc_T18;
    lm_complex mc_T19;
    lm_complex mc_T20;
    lm_complex mc_T21;
    lm_complex mc_T22;
    lm_complex mc_T23;
    lm_complex mc_T24;
    lm_complex mc_T25;
    lm_complex mc_T26;
    lm_complex mc_T27;
    lm_complex mc_T28;
    lm_complex mc_T29;
    lm_complex mc_T30;
    lm_complex mc_T31;
    lm_complex mc_T32;
    lm_complex mc_T33;
    lm_complex mc_T34;
    lm_complex mc_T35;
    lm_complex mc_T36;
    lm_complex mc_T37;
    lm_complex mc_T38;
    lm_complex mc_T39;
    lm_complex mc_T40;
    lm_complex mc_T41;
    lm_complex mc_T42;
    lm_complex mc_T43;
    lm_complex mc_T44;
    lm_complex mc_T45;
    lm_complex mc_T46;
    lm_complex mc_T47;
    lm_complex mc_T48;
    lm_complex mc_T49;
    lm_complex mc_T50;
    lm_complex mc_T51;
    lm_complex mc_T52;
    lm_complex mc_T53;
    lm_complex mc_T54;
    lm_complex mc_T55;
    lm_complex mc_T56;
    lm_complex mc_T57;
    lm_complex mc_T58;
    lm_complex mc_T59;
    lm_complex mc_T60;
    lm_complex mc_T61;
    lm_complex mc_T62;
    lm_complex mc_T63;
    lm_complex mc_T64;
    lm_complex mc_T65;
    lm_complex mc_T66;
    lm_complex mc_T67;
    lm_complex mc_T68;
    lm_complex mc_T69;
    lm_complex mc_T70;
    lm_complex mc_T71;
    lm_complex mc_T72;
    lm_complex mc_T73;
    lm_complex mc_T74;
    lm_complex mc_T75;
    lm_complex mc_T76;
    lm_complex mc_T77;
    lm_complex mc_T78;
    lm_complex mc_T79;
    lm_complex mc_T80;
    lm_complex mc_T81;
    lm_complex mc_T82;
    lm_complex mc_T83;
    lm_complex mc_T84;
    lm_complex mc_T85;
    lm_complex mc_T86;
    lm_complex mc_T87;
    lm_complex mc_T88;
    lm_complex mc_T89;
    lm_complex mc_T90;
    lm_complex mc_T91;
    lm_complex mc_T92;
    lm_complex mc_T93;
    lm_complex mc_T94;
    lm_complex mc_T95;
    lm_complex mc_T96;
    lm_complex mc_T97;
    lm_complex mc_T98;
    lm_complex mc_T99;
    lm_complex mc_T100;
    lm_complex mc_T101;
    lm_complex mc_T102;
    lm_complex mc_T103;
    lm_complex mc_T104;
    lm_complex mc_T105;
    lm_complexN mc_T106(16);
    mc_T1 = pow(xh, 15);
    mc_T2 = 9694845*mc_T1;
    mc_T3 = pow(xh, 13);
    mc_T4 = -35102025*mc_T3;
    mc_T5 = pow(xh, 11);
    mc_T6 = 50702925*mc_T5;
    mc_T7 = pow(xh, 9);
    mc_T8 = -37182145*mc_T7;
    mc_T9 = pow(xh, 7);
    mc_T10 = 14549535*mc_T9;
    mc_T11 = pow(xh, 5);
    mc_T12 = -2909907*mc_T11;
    mc_T13 = (xh*xh*xh);
    mc_T14 = 255255*mc_T13;
    mc_T15 = -6435*xh;
    mc_T16 = mc_T15+mc_T14+mc_T12+mc_T10+mc_T8+mc_T6+mc_T4+mc_T2;
    mc_T17 = mc_T16/2048;
    mc_T18 = pow(xh, 14);
    mc_T19 = 5014575*mc_T18;
    mc_T20 = pow(xh, 12);
    mc_T21 = -16900975*mc_T20;
    mc_T22 = pow(xh, 10);
    mc_T23 = 22309287*mc_T22;
    mc_T24 = pow(xh, 8);
    mc_T25 = -14549535*mc_T24;
    mc_T26 = pow(xh, 6);
    mc_T27 = 4849845*mc_T26;
    mc_T28 = (xh*xh*xh*xh);
    mc_T29 = -765765*mc_T28;
    mc_T30 = (xh*xh);
    mc_T31 = 45045*mc_T30;
    mc_T32 = -429+mc_T31+mc_T29+mc_T27+mc_T25+mc_T23+mc_T21+mc_T19;
    mc_T33 = mc_T32/2048;
    mc_T34 = 1300075*mc_T3;
    mc_T35 = -4056234*mc_T5;
    mc_T36 = 4849845*mc_T7;
    mc_T37 = -2771340*mc_T9;
    mc_T38 = 765765*mc_T11;
    mc_T39 = -90090*mc_T13;
    mc_T40 = 3003*xh;
    mc_T41 = mc_T40+mc_T39+mc_T38+mc_T37+mc_T36+mc_T35+mc_T34;
    mc_T42 = mc_T41/1024;
    mc_T43 = 676039*mc_T20;
    mc_T44 = -1939938*mc_T22;
    mc_T45 = 2078505*mc_T24;
    mc_T46 = -1021020*mc_T26;
    mc_T47 = 225225*mc_T28;
    mc_T48 = -18018*mc_T30;
    mc_T49 = 231+mc_T48+mc_T47+mc_T46+mc_T45+mc_T44+mc_T43;
    mc_T50 = mc_T49/1024;
    mc_T51 = 88179*mc_T5;
    mc_T52 = -230945*mc_T7;
    mc_T53 = 218790*mc_T9;
    mc_T54 = -90090*mc_T11;
    mc_T55 = 15015*mc_T13;
    mc_T56 = -693*xh;
    mc_T57 = mc_T56+mc_T55+mc_T54+mc_T53+mc_T52+mc_T51;
    mc_T58 = mc_T57/256;
    mc_T59 = 46189*mc_T22;
    mc_T60 = -109395*mc_T24;
    mc_T61 = 90090*mc_T26;
    mc_T62 = -30030*mc_T28;
    mc_T63 = 3465*mc_T30;
    mc_T64 = -63+mc_T63+mc_T62+mc_T61+mc_T60+mc_T59;
    mc_T65 = mc_T64/256;
    mc_T66 = 12155*mc_T7;
    mc_T67 = -25740*mc_T9;
    mc_T68 = 18018*mc_T11;
    mc_T69 = -4620*mc_T13;
    mc_T70 = 315*xh;
    mc_T71 = mc_T70+mc_T69+mc_T68+mc_T67+mc_T66;
    mc_T72 = mc_T71/128;
    mc_T73 = 6435*mc_T24;
    mc_T74 = -12012*mc_T26;
    mc_T75 = 6930*mc_T28;
    mc_T76 = -1260*mc_T30;
    mc_T77 = 35+mc_T76+mc_T75+mc_T74+mc_T73;
    mc_T78 = mc_T77/128;
    mc_T79 = 429*mc_T9;
    mc_T80 = -693*mc_T11;
    mc_T81 = 315*mc_T13;
    mc_T82 = -35*xh;
    mc_T83 = mc_T82+mc_T81+mc_T80+mc_T79;
    mc_T84 = mc_T83/16;
    mc_T85 = 231*mc_T26;
    mc_T86 = -315*mc_T28;
    mc_T87 = 105*mc_T30;
    mc_T88 = -5+mc_T87+mc_T86+mc_T85;
    mc_T89 = mc_T88/16;
    mc_T90 = 63*mc_T11;
    mc_T91 = -70*mc_T13;
    mc_T92 = 15*xh;
    mc_T93 = mc_T92+mc_T91+mc_T90;
    mc_T94 = mc_T93/8;
    mc_T95 = 35*mc_T28;
    mc_T96 = -30*mc_T30;
    mc_T97 = 3+mc_T96+mc_T95;
    mc_T98 = mc_T97/8;
    mc_T99 = 5*mc_T13;
    mc_T100 = -3*xh;
    mc_T101 = mc_T100+mc_T99;
    mc_T102 = mc_T101/2;
    mc_T103 = 3*mc_T30;
    mc_T104 = -1+mc_T103;
    mc_T105 = mc_T104/2;
    mc_T106.SetShape(16 );
    mc_T106(1) = 1;
    mc_T106(2) = xh;
    mc_T106(3) = mc_T105;
    mc_T106(4) = mc_T102;
    mc_T106(5) = mc_T98;
    mc_T106(6) = mc_T94;
    mc_T106(7) = mc_T89;
    mc_T106(8) = mc_T84;
    mc_T106(9) = mc_T78;
    mc_T106(10) = mc_T72;
    mc_T106(11) = mc_T65;
    mc_T106(12) = mc_T58;
    mc_T106(13) = mc_T50;
    mc_T106(14) = mc_T42;
    mc_T106(15) = mc_T33;
    mc_T106(16) = mc_T17;

    return mc_T106;
}

doubleN Global_TLegendreReal2Real ( const double &xh)
{
    double mc_T1;
    double mc_T2;
    double mc_T3;
    double mc_T4;
    double mc_T5;
    double mc_T6;
    double mc_T7;
    double mc_T8;
    double mc_T9;
    double mc_T10;
    double mc_T11;
    double mc_T12;
    double mc_T13;
    double mc_T14;
    double mc_T15;
    double mc_T16;
    double mc_T17;
    double mc_T18;
    double mc_T19;
    double mc_T20;
    double mc_T21;
    double mc_T22;
    double mc_T23;
    double mc_T24;
    double mc_T25;
    double mc_T26;
    double mc_T27;
    double mc_T28;
    double mc_T29;
    double mc_T30;
    double mc_T31;
    double mc_T32;
    double mc_T33;
    double mc_T34;
    double mc_T35;
    double mc_T36;
    double mc_T37;
    double mc_T38;
    double mc_T39;
    double mc_T40;
    double mc_T41;
    double mc_T42;
    double mc_T43;
    double mc_T44;
    double mc_T45;
    double mc_T46;
    double mc_T47;
    double mc_T48;
    double mc_T49;
    double mc_T50;
    double mc_T51;
    double mc_T52;
    double mc_T53;
    double mc_T54;
    double mc_T55;
    double mc_T56;
    double mc_T57;
    double mc_T58;
    double mc_T59;
    double mc_T60;
    double mc_T61;
    double mc_T62;
    double mc_T63;
    double mc_T64;
    double mc_T65;
    double mc_T66;
    double mc_T67;
    double mc_T68;
    double mc_T69;
    double mc_T70;
    double mc_T71;
    double mc_T72;
    double mc_T73;
    double mc_T74;
    double mc_T75;
    double mc_T76;
    double mc_T77;
    double mc_T78;
    double mc_T79;
    double mc_T80;
    double mc_T81;
    double mc_T82;
    double mc_T83;
    double mc_T84;
    double mc_T85;
    double mc_T86;
    double mc_T87;
    double mc_T88;
    double mc_T89;
    double mc_T90;
    double mc_T91;
    double mc_T92;
    double mc_T93;
    double mc_T94;
    double mc_T95;
    double mc_T96;
    double mc_T97;
    double mc_T98;
    double mc_T99;
    double mc_T100;
    double mc_T101;
    double mc_T102;
    double mc_T103;
    double mc_T104;
    double mc_T105;
    doubleN mc_T106(16);
    mc_T1 = pow(xh, 15);
    mc_T2 = 9694845*mc_T1;
    mc_T3 = pow(xh, 13);
    mc_T4 = -35102025*mc_T3;
    mc_T5 = pow(xh, 11);
    mc_T6 = 50702925*mc_T5;
    mc_T7 = pow(xh, 9);
    mc_T8 = -37182145*mc_T7;
    mc_T9 = pow(xh, 7);
    mc_T10 = 14549535*mc_T9;
    mc_T11 = pow(xh, 5);
    mc_T12 = -2909907*mc_T11;
    mc_T13 = (xh*xh*xh);
    mc_T14 = 255255*mc_T13;
    mc_T15 = -6435*xh;
    mc_T16 = mc_T15+mc_T14+mc_T12+mc_T10+mc_T8+mc_T6+mc_T4+mc_T2;
    mc_T17 = mc_T16/2048;
    mc_T18 = pow(xh, 14);
    mc_T19 = 5014575*mc_T18;
    mc_T20 = pow(xh, 12);
    mc_T21 = -16900975*mc_T20;
    mc_T22 = pow(xh, 10);
    mc_T23 = 22309287*mc_T22;
    mc_T24 = pow(xh, 8);
    mc_T25 = -14549535*mc_T24;
    mc_T26 = pow(xh, 6);
    mc_T27 = 4849845*mc_T26;
    mc_T28 = (xh*xh*xh*xh);
    mc_T29 = -765765*mc_T28;
    mc_T30 = (xh*xh);
    mc_T31 = 45045*mc_T30;
    mc_T32 = -429+mc_T31+mc_T29+mc_T27+mc_T25+mc_T23+mc_T21+mc_T19;
    mc_T33 = mc_T32/2048;
    mc_T34 = 1300075*mc_T3;
    mc_T35 = -4056234*mc_T5;
    mc_T36 = 4849845*mc_T7;
    mc_T37 = -2771340*mc_T9;
    mc_T38 = 765765*mc_T11;
    mc_T39 = -90090*mc_T13;
    mc_T40 = 3003*xh;
    mc_T41 = mc_T40+mc_T39+mc_T38+mc_T37+mc_T36+mc_T35+mc_T34;
    mc_T42 = mc_T41/1024;
    mc_T43 = 676039*mc_T20;
    mc_T44 = -1939938*mc_T22;
    mc_T45 = 2078505*mc_T24;
    mc_T46 = -1021020*mc_T26;
    mc_T47 = 225225*mc_T28;
    mc_T48 = -18018*mc_T30;
    mc_T49 = 231+mc_T48+mc_T47+mc_T46+mc_T45+mc_T44+mc_T43;
    mc_T50 = mc_T49/1024;
    mc_T51 = 88179*mc_T5;
    mc_T52 = -230945*mc_T7;
    mc_T53 = 218790*mc_T9;
    mc_T54 = -90090*mc_T11;
    mc_T55 = 15015*mc_T13;
    mc_T56 = -693*xh;
    mc_T57 = mc_T56+mc_T55+mc_T54+mc_T53+mc_T52+mc_T51;
    mc_T58 = mc_T57/256;
    mc_T59 = 46189*mc_T22;
    mc_T60 = -109395*mc_T24;
    mc_T61 = 90090*mc_T26;
    mc_T62 = -30030*mc_T28;
    mc_T63 = 3465*mc_T30;
    mc_T64 = -63+mc_T63+mc_T62+mc_T61+mc_T60+mc_T59;
    mc_T65 = mc_T64/256;
    mc_T66 = 12155*mc_T7;
    mc_T67 = -25740*mc_T9;
    mc_T68 = 18018*mc_T11;
    mc_T69 = -4620*mc_T13;
    mc_T70 = 315*xh;
    mc_T71 = mc_T70+mc_T69+mc_T68+mc_T67+mc_T66;
    mc_T72 = mc_T71/128;
    mc_T73 = 6435*mc_T24;
    mc_T74 = -12012*mc_T26;
    mc_T75 = 6930*mc_T28;
    mc_T76 = -1260*mc_T30;
    mc_T77 = 35+mc_T76+mc_T75+mc_T74+mc_T73;
    mc_T78 = mc_T77/128;
    mc_T79 = 429*mc_T9;
    mc_T80 = -693*mc_T11;
    mc_T81 = 315*mc_T13;
    mc_T82 = -35*xh;
    mc_T83 = mc_T82+mc_T81+mc_T80+mc_T79;
    mc_T84 = mc_T83/16;
    mc_T85 = 231*mc_T26;
    mc_T86 = -315*mc_T28;
    mc_T87 = 105*mc_T30;
    mc_T88 = -5+mc_T87+mc_T86+mc_T85;
    mc_T89 = mc_T88/16;
    mc_T90 = 63*mc_T11;
    mc_T91 = -70*mc_T13;
    mc_T92 = 15*xh;
    mc_T93 = mc_T92+mc_T91+mc_T90;
    mc_T94 = mc_T93/8;
    mc_T95 = 35*mc_T28;
    mc_T96 = -30*mc_T30;
    mc_T97 = 3+mc_T96+mc_T95;
    mc_T98 = mc_T97/8;
    mc_T99 = 5*mc_T13;
    mc_T100 = -3*xh;
    mc_T101 = mc_T100+mc_T99;
    mc_T102 = mc_T101/2;
    mc_T103 = 3*mc_T30;
    mc_T104 = -1+mc_T103;
    mc_T105 = mc_T104/2;
    mc_T106.SetShape(16 );
    mc_T106(1) = 1;
    mc_T106(2) = xh;
    mc_T106(3) = mc_T105;
    mc_T106(4) = mc_T102;
    mc_T106(5) = mc_T98;
    mc_T106(6) = mc_T94;
    mc_T106(7) = mc_T89;
    mc_T106(8) = mc_T84;
    mc_T106(9) = mc_T78;
    mc_T106(10) = mc_T72;
    mc_T106(11) = mc_T65;
    mc_T106(12) = mc_T58;
    mc_T106(13) = mc_T50;
    mc_T106(14) = mc_T42;
    mc_T106(15) = mc_T33;
    mc_T106(16) = mc_T17;

    return mc_T106;
}
\
\>", "Print",
 CellChangeTimes->{3.4894893373910923`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"InstallCode", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{3.489482668987878*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Global\"\>", "\[InvisibleSpace]", "\<\" is installed.\"\>"}],
  SequenceForm["Global", " is installed."],
  Editable->False]], "Print",
 CellChangeTimes->{3.489483145931845*^9, 3.489483186196697*^9, 
  3.4894870079670677`*^9, 3.4894872173380475`*^9, 3.4894873694913764`*^9, 
  3.489487474848728*^9, 3.4894885765150757`*^9, 3.489489136551198*^9, 
  3.489489337687961*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"compiled", "=", 
  RowBox[{"LegendreComplex2Complex", "[", 
   RowBox[{"2.5", "+", 
    RowBox[{"\[ImaginaryI]", " ", "3.5"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.489482682253248*^9, 3.4894826941748943`*^9}, {
  3.489482874155813*^9, 3.4894828764526443`*^9}, {3.4894831657595897`*^9, 
  3.4894831749312887`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"2.5`", "\[InvisibleSpace]", "+", 
    RowBox[{"3.5`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "9.5`"}], "+", 
    RowBox[{"26.25`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "194.375`"}], "+", 
    RowBox[{"51.625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1159.46875`"}], "-", 
    RowBox[{"984.375`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1139.4531250000023`", "\[InvisibleSpace]", "-", 
    RowBox[{"11775.640625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"81749.07812500001`", "\[InvisibleSpace]", "-", 
    RowBox[{"45839.88281249998`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"676531.8554687499`", "\[InvisibleSpace]", "+", 
    RowBox[{"328634.3867187502`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"943049.4663085919`", "\[InvisibleSpace]", "+", 
    RowBox[{"6.02032388671875`*^6", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "3.594910264282227`*^7"}], "+", 
    RowBox[{"3.437179259301757`*^7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "4.001794028166504`*^8"}], "-", 
    RowBox[{"8.12138092559816`*^7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1.3346102401028428`*^9"}], "-", 
    RowBox[{"3.0927844562630014`*^9", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.4719252779520107`*^10", "-", 
    RowBox[{"2.3698156555132137`*^10", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"2.3150440924425403`*^11", "-", 
    RowBox[{"1.2006673308660984`*^10", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.1835591403944177`*^12", "+", 
    RowBox[{"1.5267708757474365`*^12", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "4.8266845292792705`*^12"}], "+", 
    RowBox[{"1.5399348977869588`*^13", " ", "\[ImaginaryI]"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.4894827306741934`*^9, 3.4894828248911343`*^9, 3.489482855265551*^9, 
   3.489482899764697*^9, {3.4894829433732347`*^9, 3.4894829614822617`*^9}, 
   3.4894831017139444`*^9, 3.4894831459474697`*^9, 3.4894831862123218`*^9, 
   3.489489136566823*^9, 3.489489337703586*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"compiledn", "=", 
  RowBox[{"LegendreReal2RealNoEvaluate", "[", 
   RowBox[{"2.5", "+", 
    RowBox[{"\[ImaginaryI]", " ", "3.5"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.489489228846301*^9, 3.489489269564269*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"2.5`", "\[InvisibleSpace]", "+", 
    RowBox[{"3.5`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "9.5`"}], "+", 
    RowBox[{"26.25`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "194.375`"}], "+", 
    RowBox[{"51.625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1159.46875`"}], "-", 
    RowBox[{"984.375`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1139.4531250000023`", "\[InvisibleSpace]", "-", 
    RowBox[{"11775.640625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"81749.07812500001`", "\[InvisibleSpace]", "-", 
    RowBox[{"45839.88281249998`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"676531.8554687499`", "\[InvisibleSpace]", "+", 
    RowBox[{"328634.3867187502`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"943049.4663085919`", "\[InvisibleSpace]", "+", 
    RowBox[{"6.02032388671875`*^6", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "3.594910264282227`*^7"}], "+", 
    RowBox[{"3.437179259301757`*^7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "4.001794028166504`*^8"}], "-", 
    RowBox[{"8.12138092559816`*^7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1.3346102401028428`*^9"}], "-", 
    RowBox[{"3.0927844562630014`*^9", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.4719252779520107`*^10", "-", 
    RowBox[{"2.3698156555132137`*^10", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"2.3150440924425403`*^11", "-", 
    RowBox[{"1.2006673308660984`*^10", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.1835591403944177`*^12", "+", 
    RowBox[{"1.5267708757474365`*^12", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "4.8266845292792705`*^12"}], "+", 
    RowBox[{"1.5399348977869588`*^13", " ", "\[ImaginaryI]"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.489489337734835*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"UninstallCode", "[", "]"}], ";"}]], "Input",
 CellChangeTimes->{3.4894826746127696`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mma", "=", 
  RowBox[{"LegendreComplex2Complex", "[", 
   RowBox[{"2.5", "+", 
    RowBox[{"\[ImaginaryI]", " ", "3.5"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.489482682253248*^9, 3.4894826941748943`*^9}, {
   3.4894828674840665`*^9, 3.4894828802025723`*^9}, 3.4894831766968794`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", 
   RowBox[{"2.5`", "\[InvisibleSpace]", "+", 
    RowBox[{"3.5`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "9.5`"}], "+", 
    RowBox[{"26.25`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "194.375`"}], "+", 
    RowBox[{"51.625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1159.46875`"}], "-", 
    RowBox[{"984.375`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1139.453125`", "\[InvisibleSpace]", "-", 
    RowBox[{"11775.640625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"81749.078125`", "\[InvisibleSpace]", "-", 
    RowBox[{"45839.8828125`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"676531.85546875`", "\[InvisibleSpace]", "+", 
    RowBox[{"328634.38671875`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"943049.4663085938`", "\[InvisibleSpace]", "+", 
    RowBox[{"6.02032388671875`*^6", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "3.5949102642822266`*^7"}], "+", 
    RowBox[{"3.437179259301758`*^7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "4.001794028166504`*^8"}], "-", 
    RowBox[{"8.121380925598145`*^7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1.3346102401028442`*^9"}], "-", 
    RowBox[{"3.0927844562630005`*^9", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.4719252779520096`*^10", "-", 
    RowBox[{"2.369815655513214`*^10", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"2.3150440924425403`*^11", "-", 
    RowBox[{"1.200667330866111`*^10", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.1835591403944185`*^12", "+", 
    RowBox[{"1.5267708757474355`*^12", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "4.826684529279262`*^12"}], "+", 
    RowBox[{"1.539934897786959`*^13", " ", "\[ImaginaryI]"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.489482869640275*^9, 3.489482899811571*^9, {3.4894829434357333`*^9, 
   3.4894829615291357`*^9}, 3.4894831017451935`*^9, 3.4894831459943438`*^9, 
   3.4894831862591963`*^9, 3.48948913669182*^9, 3.4894893377817097`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"diff", "=", 
  RowBox[{"compiled", "-", "compiledn"}]}]], "Input",
 CellChangeTimes->{{3.4894892796109514`*^9, 3.489489294407542*^9}, 
   3.4894893486252513`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.489489349515859*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"diff", "=", 
  RowBox[{"compiled", "-", "mma"}]}]], "Input",
 CellChangeTimes->{{3.4894828828743963`*^9, 3.4894828887492833`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"2.2737367544323206`*^-12", "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.4551915228366852`*^-11", "+", 
    RowBox[{"2.1827872842550278`*^-11", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1.1641532182693481`*^-10"}], "+", 
    RowBox[{"1.7462298274040222`*^-10", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "1.862645149230957`*^-9"}], "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "7.450580596923828`*^-9"}], "-", 
    RowBox[{"7.450580596923828`*^-9", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "-", 
    RowBox[{"1.4901161193847656`*^-7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"1.430511474609375`*^-6", "-", 
    RowBox[{"9.5367431640625`*^-7", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.000011444091796875`", "\[InvisibleSpace]", "+", 
    RowBox[{"3.814697265625`*^-6", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.`", "\[InvisibleSpace]", "+", 
    RowBox[{"0.000125885009765625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "0.000732421875`"}], "+", 
    RowBox[{"0.0009765625`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{
    RowBox[{"-", "0.0087890625`"}], "-", 
    RowBox[{"0.001953125`", " ", "\[ImaginaryI]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4894828998271956`*^9, {3.489482943451358*^9, 3.489482961560385*^9}, 
   3.4894831017608185`*^9, 3.4894831460099688`*^9, 3.4894831862748203`*^9, 
   3.489489136707445*^9, 3.4894893378129587`*^9}]
}, Open  ]],

Cell["\<\
CleanMathCodeFiles[Confirm -> False, CleanAllBut -> {}];\
\>", "Input",
 CellChangeTimes->{{3.485169335460517*^9, 3.4851693389760513`*^9}, {
   3.4894813918873987`*^9, 3.48948139987162*^9}, 3.4894826746127696`*^9}]
}, Open  ]]
},
WindowSize->{616, 750},
WindowMargins->{{143, Automatic}, {Automatic, 65}},
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[602, 23, 127, 1, 137, "Title"],
Cell[732, 26, 139, 3, 23, "Copyright"],
Cell[CellGroupData[{
Cell[896, 33, 282, 5, 52, "Input"],
Cell[1181, 40, 521, 11, 23, "Print"]
}, Open  ]],
Cell[1717, 54, 318, 7, 31, "Input"],
Cell[2038, 63, 492, 10, 72, "Input"],
Cell[2533, 75, 656, 16, 52, "Input"],
Cell[3192, 93, 770, 19, 72, "Input"],
Cell[3965, 114, 1163, 24, 72, "Input"],
Cell[CellGroupData[{
Cell[5153, 142, 147, 3, 31, "Input"],
Cell[5303, 147, 142, 1, 23, "Print"]
}, Open  ]],
Cell[5460, 151, 126, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[5611, 157, 194, 4, 31, "Input"],
Cell[5808, 163, 13251, 512, 8039, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19096, 680, 119, 3, 31, "Input"],
Cell[19218, 685, 419, 8, 23, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19674, 698, 343, 7, 31, "Input"],
Cell[20020, 707, 2230, 47, 149, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22287, 759, 242, 5, 31, "Input"],
Cell[22532, 766, 1979, 43, 149, "Output"]
}, Open  ]],
Cell[24526, 812, 123, 3, 31, "Input"],
Cell[CellGroupData[{
Cell[24674, 819, 312, 6, 31, "Input"],
Cell[24989, 827, 2071, 44, 130, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27097, 876, 186, 4, 31, "Input"],
Cell[27286, 882, 1631, 35, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28954, 922, 154, 3, 31, "Input"],
Cell[29111, 927, 2051, 43, 130, "Output"]
}, Open  ]],
Cell[31177, 973, 224, 4, 31, "Input"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
